#!/bin/sh

#awk=/usr/bin/mawk
awk=/usr/bin/gawk

tomcat_user_par_catalina () {
   tomuser=$(ps aux|grep tomcat|grep catalina|sed 1q|awk -F " " '{
      for (i=0;i<NF;i++) {
	 if ($i == "-user") {
	    j = i+1
	    {print $j}
	 }

      }}')
   echo $tomuser
}

# tenter de récupérer l'utilisateur tomcat par /etc/passwd
tomcat_user_par_passwd() {
   tomuser=$(awk -F ":" '/tomcat/ {print $1}' /etc/passwd)
   echo $tomuser
}

# tenter de récupérer webapps par le /home de l'utilisateur tomcat
# trouvé dans /etc/passwd
webapps_dir_par_passwd() {
   webapps_dir=$(awk -F ":" '/tomcat/ {print $6}' /etc/passwd)
   echo $webapps_dir/webapps
}

# tenter de trouver l'utilisateur tomcat par les droits sur
# l'utilisateur tomcat
# parametre $1 : dossier webapps
tomcat_user_par_webapps_dir() {
   catalina_home=$(dirname "$1")
   tomcat_user=$(ls -l $catalina_home | awk -F " " '/webapps/ {print $3}')
   echo $tomcat_user
}

webapps_dir_par_catalina() {
   webapps_dir=$(ps aux|grep tomcat|grep catalina|sed 1q|$awk -F " " '{
       for (i=0;i<NF;i++) {
	   if (substr($i,0,15) == "-Dcatalina.base") {
		   {print substr($i, 17)}
	   }
      }}')
   echo $webapps_dir/webapps
}


avoir_les_droits() {
   droits=$(stat --format "%U %G %a" $1)
   echo "droits : "$droits
}

echo "tomcat user par /etc/passwd : "$(tomcat_user_par_passwd)
echo "tomcat user par catalina : "$(tomcat_user_par_catalina)
webapps_dir=$(webapps_dir_par_catalina)
echo "webapps dir par catalina : "$webapps_dir
echo "webapps dir par /etc/passwd : "$(webapps_dir_par_passwd)
tomcat_home=$(dirname "$webapps_dir")
echo "tomcat home : "$tomcat_home
echo "tomcat user par webapps dir : "$(tomcat_user_par_webapps_dir $webapps_dir)

#avoir_les_droits /var/lib/tomcat5.5/webapps/Caisse/WEB-INF/lib/openeas.jar

tomcat_user=$(tomcat_user_par_catalina)
if [ -z $tomcat_user ]
then
   tomcat_user=$(tomcat_user_par_passwd)
   if [ -z $tomcat_user ]
   then
      tomcat_user=$(tomcat_user_par_webapps_dir $webapps_dir)
   fi
fi

# Si pas trouvé, alors on prend root
tomcat_user=${tomcat_user:=root}
echo "tomcat user : "$tomcat_user
# le groupe tomcat est root si il n'est pas trouvé
tomcat_group=$(grep $tomcat_user /etc/group | gawk -F ":" '{print $1}')
echo "tomcat group avant substitution : "$tomcat_group
tomcat_group=${tomcat_group:=root}
echo "tomcat group : "$tomcat_group
